/*
Copyright (c) 2016, The `code.ivysaur/chameleon` author(s)

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above copyright
notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
THIS SOFTWARE.
*/

package chameleon

import (
	"bytes"
)

// EncodeBytes compresses an entire buffer at once.
func EncodeBytes(input []byte) ([]byte, error) {

	outputConsumer := bytes.Buffer{}

	_, err := Encode(&outputConsumer, bytes.NewReader(input))
	if err != nil {
		return nil, err
	}

	return outputConsumer.Bytes(), nil
}

// DecodeBytes decompresses an entire buffer at once.
func DecodeBytes(input []byte) ([]byte, error) {

	outputConsumer := bytes.Buffer{}

	_, err := Decode(&outputConsumer, bytes.NewReader(input))
	if err != nil {
		return nil, err
	}

	return outputConsumer.Bytes(), nil
}
